package
{
	import flash.display.*;
	import flash.events.*;
	import flash.net.SharedObject;
	import flash.ui.ContextMenu;
	import flash.ui.ContextMenuItem;
	import flash.media.*;
	import net.flashpunk.utils.Key;
	import net.flashpunk.FP;
	
	public class Audio {

		[Embed(source="music2.mp3")]	public static var music_src: Class;

		[Embed(source="bip.mp3")]	public static var bip_src: Class;
		[Embed(source="change.mp3")]	public static var change_src: Class;
		[Embed(source="goal.mp3")]	public static var goal_src: Class;
		[Embed(source="win.mp3")]	public static var win_src: Class;
		[Embed(source="slide.mp3")]	public static var slide_src: Class;
		
		
		private static var sounds:Object = {}
		private static var _mute:Boolean = false;
		private static var so:SharedObject;
		private static var menuItem:ContextMenuItem;
		
		private static var musicChannel:SoundChannel;
		private static var musicSound: Sound = new music_src();

		private static var ch:Object = {};

		public static function initialise(o:InteractiveObject): void {
			so = SharedObject.getLocal("audio", "/");
			_mute = so.data.mute;
			addContextMenu(o);
			
			//Mute key listener
			if (o.stage) addKeyListener(o.stage);
			else o.addEventListener(Event.ADDED_TO_STAGE, stageAdd);

			loadSound("bip", bip_src);
			loadSound("change", change_src);
			loadSound("goal", goal_src);
			loadSound("win", win_src);
			loadSound("slide", slide_src);
			
		}
		
		private static function loadSound(name:String, data:Class): Sound {
			return sounds[name] = new data();
		}
		
		public static function play(sound:String): void {
			if (! _mute) sounds[sound].play();
		}
		public static function loop(sound:String): void {
			if(ch[sound]) return;
			ch[sound] = sounds[sound].play(0, int.MAX_VALUE);
		}
		public static function stop(sound:String): void {
			if(ch[sound]) ch[sound].stop();
			ch[sound] = null;
		}

		public static function playMusic(): void {
			if(!mute) {
				if(!musicChannel && musicSound) musicChannel = musicSound.play(0, int.MAX_VALUE, new SoundTransform(0.4));
			}
		}
		public static function stopMusic(): void {
			if(musicChannel) musicChannel.stop();
			musicChannel = null;
		}
		
		// Getter and setter for mute property
		public static function get mute(): Boolean { return _mute; }
		public static function set mute(newValue:Boolean): void {
			if (_mute == newValue) return;
			_mute = newValue;
			menuItem.caption = _mute ? "Unmute" : "Mute";
			so.data.mute = _mute;
			so.flush();
			//Music
			if(_mute) stopMusic();
			else playMusic();
		}
		
		// Implementation details
		private static function stageAdd(e:Event): void {
			addKeyListener(e.target.stage);
		}
		
		private static function addContextMenu(o:InteractiveObject): void {
			var menu:ContextMenu = o.contextMenu || new ContextMenu;
			menu.hideBuiltInItems();
			menuItem = new ContextMenuItem(_mute ? "Unmute" : "Mute");
			menuItem.addEventListener(ContextMenuEvent.MENU_ITEM_SELECT, menuListener);
			menu.customItems.push(menuItem);
			o.contextMenu = menu;
		}
		
		private static function addKeyListener(stage:Stage): void {
			stage.addEventListener(KeyboardEvent.KEY_DOWN, keyListener);
		}
		
		private static function keyListener(e:KeyboardEvent): void {
			if(e.keyCode == Key.M) mute = ! mute;
		}
		
		private static function menuListener(e:ContextMenuEvent): void {
			mute = !mute;
		}
	}
}

