package {

	import net.flashpunk.*;
	import net.flashpunk.utils.*;
	import net.flashpunk.graphics.*;
	import flash.display.BitmapData;
	import flash.display.Graphics;
	import flash.geom.Matrix;

	public class Button extends Entity {

		private var callback:Function;
		private var a: Stamp;
		private var b: Stamp;
		private var offset:Number = 0;
		
		public function Button(caption:String, x:Number, y:Number, width:Number, height:Number, callback:Function) {
			super(x, y);
			setHitbox(width, height);
			this.callback = callback;

			var d:Number = Math.max(width, height) * 0.04;
			var g:Graphics = FP.sprite.graphics;
			g.clear();
			g.beginFill(0x00, 1);
			g.moveTo(0,0);
			g.lineTo(width*0.7, d);
			g.lineTo(d*2, d*2);
			g.lineTo(d, height*0.7);
			g.lineTo(0, 0);
			g.endFill();

			// Edges
			var bmp:BitmapData;
			bmp = new BitmapData(width*0.7, height*0.7, true, 0);
			bmp.draw(FP.sprite, null, null, null);
			a = new Stamp(bmp);
			bmp = new BitmapData(width*0.7, height*0.7, true, 0);
			bmp.draw(FP.sprite, new Matrix(-1,0,0,-1, bmp.width, bmp.height), null, null);
			b = new Stamp(bmp, width - bmp.width, height - bmp.height);

			addGraphic(a);
			addGraphic(b);

			// Text
			if(caption!=null) {
				var text:Text = new Text(caption, 0,0, { font:"brush", size:24, color:0x0 });
				text.x = width/2 - text.textWidth/2;
				text.y = height/2 - text.textHeight/2;
				addGraphic(text);
			}

			graphic.scrollX = graphic.scrollY = 0;
		}


		public override function update(): void {
			const speed:Number = 0.04
			if(collidePoint(x,y, Input.mouseX, Input.mouseY)) {
				if(offset==0) Audio.play("bip");
				offset = Math.min(1.0, offset+speed);
				if(Input.mousePressed && callback!=null) callback();
			} else {
				offset = Math.max(0.0, offset-speed);
			}
			var o:Number = offset * 3.0;
			a.x = a.y = -o;
			b.x = width - b.width + o;
			b.y = height - b.height + o;
		}

	}

}
