package {

	import flash.display.*;
	import flash.text.*;
	import flash.events.*;
	import flash.utils.getDefinitionByName;

	[SWF(width = "600", height = "480")]
	public class Preloader extends Sprite {
		public static var main: String = "Main";
		public static const BG_COLOUR:uint = 0x000000;
		public static const FG_COLOUR:uint = 0x0080ff;
		public static const TX_COLOUR:uint = 0xffffff;

		private var text:TextField;
		private var swidth:int;
		private var sheight:int;

		[Embed(source = 'net/flashpunk/graphics/04B_03__.TTF', fontFamily = 'default')]
		private static const FONT:Class;
		
		public function Preloader() {
			if(stage) onStageAdd();
			else addEventListener(Event.ADDED_TO_STAGE, onStageAdd);
		}

		public function onStageAdd(e:Event=null): void{
			//Setup
			swidth = stage.stageWidth;
			sheight = stage.stageHeight;

			//Text
			text = new TextField();
			text.textColor = TX_COLOUR;
			text.selectable = false;
			text.mouseEnabled = false;
			text.defaultTextFormat = new TextFormat("default", 16);
			text.embedFonts = true;
			text.autoSize = "left";
			text.text = "0%";
			text.x = (swidth - text.width) * 0.5;
			text.y = (sheight - text.height) * 0.5;
			addChild(text);
			
			stage.addEventListener(Event.ENTER_FRAME, onEnterFrame);
		}

		public function onEnterFrame(e:Event): void {
			if(hasLoaded) startup();
			else {
				var value:Number = (loaderInfo.bytesLoaded / loaderInfo.bytesTotal);
				var w: Number = swidth * 0.8;
				var h: Number = 20;
				var x: Number = swidth*0.5 - w*0.5;
				var y: Number = sheight*0.5 - 10;
				//Background
				graphics.clear();
				graphics.beginFill(BG_COLOUR);
				graphics.drawRect(0, 0, swidth, sheight);
				graphics.endFill();
				//Progress bar
				graphics.lineStyle(2, FG_COLOUR, 1, false, LineScaleMode.NONE);
				renderBar(graphics, x, y, w, h, 10);
				graphics.beginFill(FG_COLOUR, 1);
				renderBar(graphics, x+2, y+4, (w-4) * value, h-8, 6);
				graphics.endFill();
				//Text
				text.text = int(value * 100) + "%";
				text.x = (swidth - text.width) * 0.5;
			}
			
		}
		
		private function renderBar(gfx:Graphics, x:Number, y:Number, w:Number, h:Number, bend:Number): void {
			gfx.moveTo(x,y);
			gfx.lineTo(x+w,y);
			gfx.curveTo(x+w+bend,y+h/2, x+w,y+h);
			gfx.lineTo(x,y+h);
			gfx.curveTo(x-bend,y+h/2, x,y);
		}
		
		private function get hasLoaded (): Boolean {
			return (loaderInfo.bytesLoaded >= loaderInfo.bytesTotal);
		}

		private function startup (): void {
			stage.removeEventListener(Event.ENTER_FRAME, onEnterFrame);
			var mainClass:Class = getDefinitionByName(main) as Class;
			parent.addChild(new mainClass as DisplayObject);
			parent.removeChild(this);
		}
	}
}


