package {

	import net.flashpunk.FP;
	import net.flashpunk.graphics.Stamp;
	import flash.display.BitmapData;
	import flash.display.Graphics;
	import flash.geom.Matrix;
	
	public class Push extends GameObject {
		public var direction: int;
		
		public function Push(x:Number, y:Number, direction:int) {
			super(x,y);
			this.direction = direction;

			// Make graphic
			var colour:uint = 0xb0b0b0;
			var s:Number = Shape.radius * 0.5;
			var t:Number = s - 4;
			var a:Number = (3-direction) * Math.PI/2;
			var step: Number = Math.PI * 2/3;
			var g:Graphics = FP.sprite.graphics;
			g.clear();
			g.lineStyle(3, colour, 1.0);
			g.drawCircle(0,0,s);
			g.moveTo(Math.sin(a)*t, Math.cos(a)*t); a+=step;
			g.beginFill(colour, 1.0);
			g.lineStyle(1, colour, 1.0);
			g.lineTo(Math.sin(a)*t, Math.cos(a)*t); a+=step;
			g.lineTo(Math.sin(a)*t, Math.cos(a)*t); a+=step;
			g.lineTo(Math.sin(a)*t, Math.cos(a)*t);
			g.endFill();
			// Convert to stamp
			var bmp:BitmapData = new BitmapData(s*2+4, s*2+4, true, 0x0);
			bmp.draw(FP.sprite, new Matrix(1,0,0,1,s+2, s+2), null, null);
			graphic = new Stamp(bmp, -(s+2), -(s+2));
			setHitboxTo(graphic);
		}

		/** Push */
		public override function update(): void {
			var r:Number = Shape.radius/2; // Shape.radius - this.radius;
			var game:Game = world as Game;
			for each(var s:Shape in game.shapes) {
				if(FP.distanceSquared(x,y,s.x, s.y) < r*r) {
					// So, its touching, do something about it!
					if(s.moving) {
						if((s.my==0?1:0) ^ (direction&1)) {
							if(s.canMove(direction)) s.move(direction);
						} else {
							trace("Across");
							var v: Boolean = (direction&1)>0; // Vertical arrow
							var d:Number = v? Math.abs(x-s.x): Math.abs(y-s.y);
							if(d<4) {
								// Move to centre, send in direction.
								var cx:Number = v? x: s.x;
								var cy:Number = v? s.y: y;
								var dir: Object = dVec;
								if(!game.collide(s, cx, cy)) {
									if(!game.collide(s, cx+dir.x, cy+dir.y)) {
										s.x = cx; s.y=cy;
										s.move(direction);
									}
								} else if(!game.collide(s, s.x+dir.x, s.y+dir.y)) {
									s.move(direction);
								}
							}
						}
					} else if(s.canMove(direction)) s.move(direction);
				}
				
			}
		}

		private function get dVec(): Object {
			switch(direction) {
			case 1: return { x: 0, y:-1 };
			case 2: return { x: 1, y: 0 };
			case 3: return { x: 0, y: 1 };
			case 4: return { x:-1, y: 0 };
			default: return null;
			}
		}
	}
}
