package {
	import net.flashpunk.*;
	import net.flashpunk.utils.*;
	import net.flashpunk.graphics.*;
	import flash.display.BitmapData;


	public class Title extends World {
		[Embed(source="BRUSHSTP.ttf", embedAsCFF="false", fontFamily="brush")]	public static var BRUSHSTP_src: Class;

		public function Title() {
			// Build background
			var back:BitmapData = new BitmapData(FP.width, FP.height);
			var ts:Object = { size:128, color:0x00, width:FP.width, align:"center", font:"brush" };
			var shape:Image = Shape.createGraphic(5, 200);
			shape.alpha = 0.2;
			Draw.setTarget(back);
			Draw.text("Kriok", 0, 60, ts);
			Draw.graphic(shape, 180, 210);
			Draw.resetTarget();
			addGraphic( new Stamp(back) );

			// Buttons
			add( new Button("Play", 250, 280, 100, 40, play) );
			add( new Button("Select", 250, 350, 100, 40, levels) );

			// Create some levels
			if(Level.list.length==0) {
				Data.load("kriok");
				Level.loadList( new Level.levels_src );
			}
		}

		public function play(): void {
			GameStats.play();
			// Get next level to play
			var level:Level = Level.list[0];
			for each(var l:Level in Level.list) if(!l.locked) level = l;
			if(level==Level.list[ Level.list.length-1]) level = Level.list[0];
			Transition.fadeOut( new Game(level), 0xffffff );
			Audio.play("change");
			trace("Play game");
		}

		public function levels(): void {
			Transition.fadeOut( new LevelSelect(), 0xffffff );
			Audio.play("change");
			trace("Level Selection");
		}

		

	}
}
